diff --git a/include/sys/wait.h b/include/sys/wait.h
index 5ac9cd6ca6..39a327f6b2 100644
--- a/include/sys/wait.h
+++ b/include/sys/wait.h
@@ -15,5 +15,6 @@ extern __pid_t __wait3 (int *__stat_loc,
 extern __pid_t __wait4 (__pid_t __pid, int *__stat_loc,
 			int __options, struct rusage *__usage)
 			attribute_hidden;
+libc_hidden_proto (__wait4);
 #endif
 #endif
diff --git a/posix/wait4.c b/posix/wait4.c
index eb4f7fb6de..5857b4e7c1 100644
--- a/posix/wait4.c
+++ b/posix/wait4.c
@@ -26,5 +26,5 @@ __wait4 (__pid_t pid, int *stat_loc, int options, struct rusage *usage)
   return (pid_t) -1;
 }
 stub_warning (wait4)
-
+libc_hidden_def (__wait4)
 weak_alias (__wait4, wait4)
diff --git a/posix/waitpid.c b/posix/waitpid.c
index adae03918a..0490c37316 100644
--- a/posix/waitpid.c
+++ b/posix/waitpid.c
@@ -1,4 +1,5 @@
-/* Copyright (C) 1991-2019 Free Software Foundation, Inc.
+/* Wait for process to change state.
+   Copyright (C) 1991-2019 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -16,35 +17,14 @@
    <https://www.gnu.org/licenses/>.  */
 
 #include <errno.h>
+#include <sysdep-cancel.h>
+#include <stdlib.h>
 #include <sys/wait.h>
-#include <sys/types.h>
 
-
-/* Wait for a child matching PID to die.
-   If PID is greater than 0, match any process whose process ID is PID.
-   If PID is (pid_t) -1, match any process.
-   If PID is (pid_t) 0, match any process with the
-   same process group as the current process.
-   If PID is less than -1, match any process whose
-   process group is the absolute value of PID.
-   If the WNOHANG bit is set in OPTIONS, and that child
-   is not already dead, return (pid_t) 0.  If successful,
-   return PID and store the dead child's status in STAT_LOC.
-   Return (pid_t) -1 for errors.  If the WUNTRACED bit is set in OPTIONS,
-   return status for stopped children; otherwise don't.  */
-pid_t
-__waitpid (pid_t pid, int *stat_loc, int options)
+__pid_t
+__waitpid (__pid_t pid, int *stat_loc, int options)
 {
-  if ((options & ~(WNOHANG|WUNTRACED)) != 0)
-    {
-      __set_errno (EINVAL);
-      return (pid_t) -1;
-    }
-
-  __set_errno (ENOSYS);
-  return (pid_t) -1;
+  return __wait4 (pid, stat_loc, options, NULL);
 }
 libc_hidden_def (__waitpid)
 weak_alias (__waitpid, waitpid)
-
-stub_warning (waitpid)
diff --git a/sysdeps/mach/hurd/wait4.c b/sysdeps/mach/hurd/wait4.c
index 78ad33e8f5..a0137482c4 100644
--- a/sysdeps/mach/hurd/wait4.c
+++ b/sysdeps/mach/hurd/wait4.c
@@ -49,5 +49,5 @@ __wait4 (pid_t pid, int *stat_loc, int options, struct rusage *usage)
       return (pid_t) __hurd_fail (err);
     }
 }
-
+libc_hidden_def (__wait4)
 weak_alias (__wait4, wait4)
diff --git a/sysdeps/unix/bsd/waitpid.c b/sysdeps/unix/bsd/waitpid.c
deleted file mode 100644
index 679d45d3dd..0000000000
--- a/sysdeps/unix/bsd/waitpid.c
+++ /dev/null
@@ -1,42 +0,0 @@
-/* Copyright (C) 1991-2019 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <sys/wait.h>
-#include <sys/types.h>
-#include <stddef.h>
-
-/* Wait for a child matching PID to die.
-   If PID is greater than 0, match any process whose process ID is PID.
-   If PID is (pid_t) -1, match any process.
-   If PID is (pid_t) 0, match any process with the
-   same process group as the current process.
-   If PID is less than -1, match any process whose
-   process group is the absolute value of PID.
-   If the WNOHANG bit is set in OPTIONS, and that child
-   is not already dead, return (pid_t) 0.  If successful,
-   return PID and store the dead child's status in STAT_LOC.
-   Return (pid_t) -1 for errors.  If the WUNTRACED bit is set in OPTIONS,
-   return status for stopped children; otherwise don't.  */
-pid_t
-__waitpid (pid_t pid, int *stat_loc, int options)
-{
-  return __wait4 (pid, stat_loc, options, NULL);
-}
-
-libc_hidden_def (__waitpid)
-weak_alias (__waitpid, waitpid)
diff --git a/sysdeps/unix/sysv/linux/wait4.c b/sysdeps/unix/sysv/linux/wait4.c
index d09917c7ff..203deb7730 100644
--- a/sysdeps/unix/sysv/linux/wait4.c
+++ b/sysdeps/unix/sysv/linux/wait4.c
@@ -85,4 +85,5 @@ __wait4 (pid_t pid, int *stat_loc, int options, struct rusage *usage)
 # error "The kernel ABI does not provide a way to implement wait4"
 #endif
 }
+libc_hidden_def (__wait4);
 weak_alias (__wait4, wait4)
diff --git a/sysdeps/unix/sysv/linux/waitpid.c b/sysdeps/unix/sysv/linux/waitpid.c
deleted file mode 100644
index d35aac01bc..0000000000
--- a/sysdeps/unix/sysv/linux/waitpid.c
+++ /dev/null
@@ -1,34 +0,0 @@
-/* Linux waitpid syscall implementation.
-   Copyright (C) 1991-2019 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <sysdep-cancel.h>
-#include <stdlib.h>
-#include <sys/wait.h>
-
-__pid_t
-__waitpid (__pid_t pid, int *stat_loc, int options)
-{
-#ifdef __NR_waitpid
-  return SYSCALL_CANCEL (waitpid, pid, stat_loc, options);
-#else
-  return SYSCALL_CANCEL (wait4, pid, stat_loc, options, NULL);
-#endif
-}
-libc_hidden_def (__waitpid)
-weak_alias (__waitpid, waitpid)